import snowflake.connector
import os

# Provide a comma-separated list of database names to extract the required DDLs.
databases = 'NEWDB,ANOTHERDB'

# Empty to extract DDLs from all the databases.
# databases = ''

# Path where DDL dumps needs to be exported. 
fpath = r"D:\export\tmp\Snowflake_ddl"

# Snowflake connection details
SnowflakeConn = snowflake.connector.connect(
user='username',
password='Password',
account='SnowflakeHost(Exclude .snowflakecomputing.com from host URL)',
database='database',
warehouse='warehouse',
schema='schema'
)
sqlConn = SnowflakeConn.cursor()

try:
    fileName = os.path.join(fpath, "snowflake_database_ddls_export.sql")
    file = open(fileName, "w")
    if len(databases) != 0:
        db_list = databases.split(',')
        for db in db_list:
            sql_ddl_object = "SELECT GET_DDL('DATABASE', '" + db + "', true)"
            sqlConn.execute(sql_ddl_object)
            row_ddl_table = sqlConn.fetchall()
            # print(row_ddl_table[0][0])
            file.write(str(row_ddl_table[0][0]))
            file.write("\n\n")
    else:
        print("============================================================================\n")
        print("Db list is empty. Exporting DDL's for All Databases!\n")
        print("============================================================================\n")


        # Database Definition
        # Exclude all shared databases
        sql_select_databases = "SELECT DATABASE_NAME DATABASE_NAME FROM INFORMATION_SCHEMA.DATABASES where DATABASE_NAME" \
                               " NOT IN ( 'SNOWFLAKE_SAMPLE_DATA');"
        sqlConn.execute(sql_select_databases)
        rows = sqlConn.fetchall()
        for row in rows:
            sql_ddl_object = "SELECT GET_DDL('DATABASE', '" + row[0] + "', true)"
            sqlConn.execute(sql_ddl_object)
            row_ddl_table = sqlConn.fetchall()
            file.write(str(row_ddl_table[0][0]))
            file.write("\n\n")

    file.close()

except Exception as e:
    print(e)
finally:
    sqlConn.close()
